package com.millenniumit;


import com.vaadin.annotations.Push;
import com.vaadin.server.VaadinRequest;
import com.vaadin.shared.communication.PushMode;
import com.vaadin.shared.ui.ui.Transport;
import com.vaadin.ui.Button;
import com.vaadin.ui.Component;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.Button.ClickEvent;

import java.time.Instant;

/**
 * Created by Manura on 2/07/2014.
 */
@Push
public class pushUI extends UI{


    final Label label = new Label( "Now : " );

    @Override
    protected void init(VaadinRequest vaadinRequest) {

        System.out.println("WS Request -----------------");


        Button refresh = new Button("Refresh",new Button.ClickListener(){

    		private static final long serialVersionUID = 1L;

    		@Override
    		public void buttonClick(ClickEvent event) {
                System.out.println("click button---");
                setContent(label);

    	        new FeederThread().start();
    		}		
    	});	
    	setContent(refresh);


    	

        
        
    }

    public void tellTime ()
    {
        label.setValue( "Now : " +  Instant.now() );
        System.out.println("Time set---" +Instant.now());
    }

    public void close(){
        getUI().close();
    }


    class FeederThread extends Thread{

    	
    	int count=0;
    	

    	@Override
    	public void run() {
    		// Update the data for a while
    		try {
	    		while(count<10000){
		    		 Thread.sleep(1000);
		    		 access(new Runnable() {
		    		 	
		    		 	@Override
		    		 	public void run() {
                            count ++;
                            tellTime();
		    		 	}
		    		 });	    				
	    		}
	    		
	    		// Inform that we have stopped running
	    		access(new Runnable() {
					
					@Override
					public void run() {
						setContent(new Label("Done....!!"));
						
					}
				});
	    		setContent(new Label("Done....!!"));

	    			
	    	}
    		catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    }
}
